SystemOrganization addCategory: #'StashShell-MC'!

StashDevice subclass: #StashMCConfigs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-MC'!

!StashMCConfigs classSide methodsFor: 'testing' stamp: 'DaleHenrichs 12/11/2010 13:52'!
isMountable

	^true! !

!StashMCConfigs classSide methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 14:11'!
mountName
	^'configs'! !

!StashMCConfigs methodsFor: 'builtins' stamp: 'DaleHenrichs 12/11/2010 13:32'!
listContentsWithOptions: options
	| stream first |
	stream := WriteStream on: String new.
	first := true.
	((MetacelloToolBox configurationClasses
		collect: [ :each | 
			| configName |
			configName := each name asString.
			(configName beginsWith: 'ConfigurationOf')
				ifTrue: [ configName copyFrom: 'ConfigurationOf' size + 1 to: configName size ]
				ifFalse: [ configName ] ]) asArray sort: [ :a :b | a <= b ])
		do: [ :configName | 
			first
				ifFalse: [ stream cr ].
			stream nextPutAll: configName.
			first := false ].
	^ stream contents! !

!StashMCConfigs methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 13:28'!
lookupChildNamed: aString ifAbsent: absentBlock
	(StashShellNoSuchChild signal: aString)
		ifTrue: [ absentBlock value ]! !

!StashMCConfigs methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 16:02'!
name
	name ifNil: [^self class mountName ].
	^name! !

StashDevice subclass: #StashMCPackages
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-MC'!

!StashMCPackages classSide methodsFor: 'testing' stamp: 'DaleHenrichs 12/11/2010 13:52'!
isMountable

	^true! !

!StashMCPackages classSide methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 14:11'!
mountName
	^'pkgs'! !

!StashMCPackages methodsFor: 'builtins' stamp: 'DaleHenrichs 12/11/2010 13:16'!
listContentsWithOptions: options
	| stream first |
	stream := WriteStream on: String new.
	first := true.
	((MCWorkingCopy allManagers collect: [ :each | each packageName ]) asArray sort: [ :a :b | a <= b ])
		do: [ :packageName | 
			first
				ifFalse: [ stream cr ].
			stream nextPutAll: packageName.
			first := false ].
	^ stream contents! !

!StashMCPackages methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 13:28'!
lookupChildNamed: aString ifAbsent: absentBlock
	(StashShellNoSuchChild signal: aString)
		ifTrue: [ absentBlock value ]! !

!StashMCPackages methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 16:02'!
name
	name ifNil: [^self class mountName ].
	^name! !

StashDevice subclass: #StashMCRepositories
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'StashShell-MC'!

!StashMCRepositories classSide methodsFor: 'testing' stamp: 'DaleHenrichs 12/11/2010 13:53'!
isMountable

	^true! !

!StashMCRepositories classSide methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 14:11'!
mountName
	^'repos'! !

!StashMCRepositories methodsFor: 'builtins' stamp: 'DaleHenrichs 12/11/2010 13:17'!
listContentsWithOptions: options
	| stream first |
	stream := WriteStream on: String new.
	first := true.
	((MCRepositoryGroup default repositories collect: [ :each | each description ]) asArray sort: [ :a :b | a <= b ])
		do: [ :packageName | 
			first
				ifFalse: [ stream cr ].
			stream nextPutAll: packageName.
			first := false ].
	^ stream contents! !

!StashMCRepositories methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 13:28'!
lookupChildNamed: aString ifAbsent: absentBlock
	(StashShellNoSuchChild signal: aString)
		ifTrue: [ absentBlock value ]! !

!StashMCRepositories methodsFor: 'accessing' stamp: 'DaleHenrichs 12/11/2010 16:02'!
name
	name ifNil: [^self class mountName ].
	^name! !
